﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace N2.Details
{
	using System.ComponentModel;
	
	public class ContentItemTypeDescriptionProvider
		: TypeDescriptionProvider
	{
		#region Fields

		readonly TypeDescriptionProvider parent;
		
		#endregion Fields

		#region Constructors

		public ContentItemTypeDescriptionProvider()
			: base()
		{
			this.parent = TypeDescriptor.GetProvider(typeof(ContentItem));
		}

		#endregion Constructors

		public override ICustomTypeDescriptor GetTypeDescriptor(Type objectType, object instance)
		{
			if (!(instance is ContentItem)) {
				throw new ArgumentException("instance");
			}
			
			return new ContentItemTypeDescriptor(
				this.parent.GetTypeDescriptor(objectType),
				instance as ContentItem);
		}
	}
}
