﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace N2.Details
{
	using System.ComponentModel;
	
	public class ContentItemTypeDescriptor
		: CustomTypeDescriptor
	{
		#region Constructors

		public ContentItemTypeDescriptor(
				ICustomTypeDescriptor parent,
				ContentItem contentItem)
			: base(parent)
		{
			this.instance = contentItem;
		}
		
		#endregion Constructors

		#region Fields

		protected readonly ContentItem instance;

		#endregion Fields

		public override string GetClassName()
		{
			return instance.GetType().Name;
		}

		public override PropertyDescriptorCollection GetProperties()
		{
			return this.GetProperties(null);
		}

		public override PropertyDescriptorCollection GetProperties(Attribute[] attributes)
		{
			return
				new PropertyDescriptorCollection((
					from _category in this.instance.DetailCollections
					from _property in _category.Value.Details
					select new ContentItemPropertyDescriptor(
						TypeDescriptor.CreateProperty(
								typeof(ContentItem),
								_property.Name,
								typeof(string)),
							_property,
							_category.Key
						)
					).ToArray());
		}
	}
}
