﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace N2.Details
{
	using System.Web.UI;
	using Xacc;
	
	public class EditablePropertyGridAttribute:
		AbstractEditableAttribute,
		IDisplayable
	{
		#region Constructors

		public EditablePropertyGridAttribute()
			: base()
		{ }

		public EditablePropertyGridAttribute(
				string title,
				int sortOrder): base(title, sortOrder)
		{ }

		#endregion Constructors

		#region IDisplayable Members

		public Control AddTo(ContentItem item, string detailName, System.Web.UI.Control container)
		{
			var _pg = new PropertyGrid {
				SelectedObject = item,
				SupressEmbeddedJQuery = true
			};

			container.Controls.Add(_pg);
			return _pg;
		}

		#endregion

		#region AbstractEditableAttribute overrides

		protected override Control AddEditor(Control container)
		{
			var _pg = new PropertyGrid {
				ID = this.Name,
				SupressEmbeddedJQuery = true
			};

			container.Controls.Add(_pg);
			return _pg;
		}

		public override void UpdateEditor(ContentItem item, Control editor)
		{
			var _pg = editor as PropertyGrid;
			_pg.SelectedObject = item;
		}

		public override bool UpdateItem(ContentItem item, Control editor)
		{
			var _pg = editor as PropertyGrid;
			
			//item = _pg.SelectedObject as ContentItem;
			return false;
		}

		#endregion AbstractEditableAttribute overrides
	}
}
